#import "Fiend.h"

RCSID ("$Id: ActiveApplicationsController.m,v 1.1.1.1 1998/09/03 01:14:55 nygard Exp $");

#import "ActiveApplicationsController.h"

#import "FIAppInfo.h"

@implementation ActiveApplicationsController

+ sharedActiveApplicationsController
{
    static ActiveApplicationsController *instance = nil;

    if (instance == nil)
        instance = [[ActiveApplicationsController alloc] init];

    return instance;
}

//----------------------------------------------------------------------

- init
{
    if ([super initWithWindowNibName:@"ActiveApplications"] == nil)
        return nil;

    // This has no effect when we run the panel modally.
    [self setWindowFrameAutosaveName:@"ActiveApplications"];

    activeApplications = nil;

    return self;
}

//----------------------------------------------------------------------

- (void) dealloc
{
    SNRelease (activeApplications);
    
    [super dealloc];
}

//----------------------------------------------------------------------

- (void) showWindow:sender
{
    if ([self isWindowLoaded] == YES)
        [self updateAction:self];

    [super showWindow:sender];
}

//----------------------------------------------------------------------

- (void) windowDidLoad
{
    [self updateAction:self];
}

//----------------------------------------------------------------------

- (void) updateAction:sender
{
    SNRelease (activeApplications);
    activeApplications = [[[FIAppInfo activeAppInfo] allValues] retain]; // XXX: unsorted.
    [activeApplicationTableView reloadData];
}

//======================================================================
// NSTableView data source
//======================================================================

- (int) numberOfRowsInTableView:(NSTableView *)aTableView
{
    return [activeApplications count];
}

//----------------------------------------------------------------------

- tableView:(NSTableView *)aTableView objectValueForTableColumn:(NSTableColumn *)aTableColumn row:(int)rowIndex
{
    NSString *identifier;
    FIAppInfo *target;
    id value;

    NSParameterAssert (rowIndex >= 0 && rowIndex < [activeApplications count]);

    value = nil;

    target = [activeApplications objectAtIndex:rowIndex];
    identifier = [aTableColumn identifier];

    if ([identifier isEqualToString:@"ShortName"])
    {
        value = [target shortName];
    }
    else if ([identifier isEqualToString:@"PID"])
    {
        value = [NSNumber numberWithInt:[target pid]];
    }
    else if ([identifier isEqualToString:@"Context"])
    {
        value = [NSNumber numberWithInt:[target ownerContext]];
    }
    else if ([identifier isEqualToString:@"TokenWindow"])
    {
        value = [NSNumber numberWithInt:[target tokenWindowNumber]];
    }
    else if ([identifier isEqualToString:@"UserName"])
    {
        value = [target userName];
    }

    return value;
}

@end
