//
// $Id: FILevel.h,v 1.1.1.1 1998/09/03 01:14:51 nygard Exp $
//

#import <Foundation/Foundation.h>

@class FITile;
@class FIDock;

@interface FILevel : NSObject
{
    FIDock *nonretainedDock;
    
    NSString *levelName;
    NSMutableArray *tiles;

    BOOL isPersistent;
}

+ (void) initialize;

- initWithDock:(FIDock *)aDock;
- (void) dealloc;

- (void) loadApplications:(NSArray *)savedApplications;
- (NSDictionary *) levelPropertyList; // Change to propertyListForLevel...

- (FIDock *) dock;

- (NSString *) levelName;
- (void) setLevelName:(NSString *)newName;

- (BOOL) isPersistent;
- (void) setIsPersistent:(BOOL)flag;

- (NSArray *) tiles;
- (void) addTile:(FITile *)newTile;

- (BOOL) containsApplication:(NSString *)applicationPath;
- (BOOL) isDockLocationEmpty:(DockLocation)aLocation;

- (void) hideLevel;
- (void) unhideLevel;
- (void) setTileWindowLevel:(int)level;

- (void) clearLevel;
- (void) rotateTilesAroundPoint:(NSPoint)origin;
- (void) repositionRelativeToPoint:(NSPoint)origin;

- (void) checkForActiveApplications:(NSDictionary *)activeApplications;
- (void) performAutoLaunch;
- (void) hideSourceTiles;
- (void) unhideSourceTiles;
- (void) updateTileViews;

- (void) deleteTiles:(NSArray *)someTiles;
- (void) removeTile:(FITile *)aTile;
- (void) updateChangeCount;

//----------------------------------------------------------------------
// NSWorkspace notifications
//----------------------------------------------------------------------

- (void) applicationWillLaunch:(NSNotification *)aNotification;
- (void) applicationDidLaunch:(NSNotification *)aNotification;
- (void) applicationDidTerminate:(NSNotification *)aNotification;

//----------------------------------------------------------------------
// Fiend Launcher notifications
//----------------------------------------------------------------------

- (void) applicationLaunchFailed:(NSNotification *)aNotification;

@end
