#import "Fiend.h"

RCSID ("$Id: FISoundManager.m,v 1.1.1.1 1998/09/03 01:14:56 nygard Exp $");

#import "FISoundManager.h"
#import <SoundKit/SoundKit.h>

@implementation FISoundManager

+ sharedSoundManager
{
    static FISoundManager *instance = nil;

    if (instance == nil)
        instance = [[FISoundManager alloc] init];

    return instance;
}

//----------------------------------------------------------------------

- init
{
    if ([super init] == nil)
        return nil;

    defaults = [NSUserDefaults standardUserDefaults];
    fiendSound = [[Sound findSoundFor:@"Destroy"] retain];
    destroySound = [[Sound findSoundFor:@"Fiend"] retain];

    return self;
}

//----------------------------------------------------------------------

- (void) dealloc
{
    SNRelease (defaults);
    SNRelease (fiendSound);
    SNRelease (destroySound);

    [super dealloc];
}

//----------------------------------------------------------------------

- (BOOL) shouldPlaySound
{
    return [defaults boolForKey:DK_UseSounds];
}

//----------------------------------------------------------------------

- (void) didAddTiles
{
    if ([self shouldPlaySound] == YES)
    {
        //NSLog (@"playing add sound...");
        [fiendSound play];
    }
}

//----------------------------------------------------------------------

- (void) didRemoveTiles
{
    if ([self shouldPlaySound] == YES)
    {
        //NSLog (@"playing destroy sound...");
        [destroySound play];
    }
}

@end
