#import "Fiend.h"

RCSID ("$Id: FISwapView.m,v 1.1.1.1 1998/09/03 01:14:56 nygard Exp $");

#import "FISwapView.h"
#import "FISwappedViewController.h"

@implementation FISwapView

- initWithFrame:(NSRect)frameRect
{
    if ([super initWithFrame:frameRect] == nil)
        return nil;

    swappedViewController = nil;
    contentView = nil;

    return self;
}

//----------------------------------------------------------------------

- (void) dealloc
{
    SNRelease (swappedViewController);
    SNRelease (contentView);

    [super dealloc];
}

//----------------------------------------------------------------------

- (FISwappedViewController *) swappedViewController
{
    return swappedViewController;
}

//----------------------------------------------------------------------

- (void) setSwappedViewController:(FISwappedViewController *)newSwappedViewController
{
    if (newSwappedViewController == swappedViewController)
        return;

    SNRelease (swappedViewController);
    swappedViewController = [newSwappedViewController retain];

    [self setContentView:[swappedViewController contentView]];
}

//----------------------------------------------------------------------

- (NSView *) contentView
{
    return contentView;
}

//----------------------------------------------------------------------

- (void) setContentView:(NSView *)newContentView
{
    NSPoint viewOrigin;
    NSRect boundsRect, contentViewBounds;

    if (newContentView == contentView)
        return;

    [contentView removeFromSuperview];
    SNRelease (contentView);
    contentView = [newContentView retain];
    if (contentView != nil)
    {
        [swappedViewController willSwapInContentView];
        [self addSubview:contentView];
        viewOrigin = NSZeroPoint;
        boundsRect = [self bounds];
        contentViewBounds = [contentView bounds];

        if ([swappedViewController centerViewHorizontally] == YES)
        {
            viewOrigin.x = floor ((boundsRect.size.width - contentViewBounds.size.width) / 2);
        }

        if ([swappedViewController centerViewVertically] == YES)
        {
            viewOrigin.y = floor ((boundsRect.size.height - contentViewBounds.size.height) / 2);
        }

        [contentView setFrameOrigin:viewOrigin];
        [swappedViewController didSwapInContentView];
    }
}

@end
