//
// $Id: FITileView.h,v 1.1.1.1 1998/09/03 01:14:52 nygard Exp $
//

#import <AppKit/AppKit.h>

@interface FITileView : NSControl
{
    NSImage *image;
    NSPoint compositePoint;

    id nonretainedDelegate;
    id nonretainedDatasource;
}

+ (void) initialize;

- initWithFrame:(NSRect)frameRect;
- (void) dealloc;

- (NSImage *) image;
- (void) setImage:(NSImage *)newImage;

- delegate;
- (void) setDelegate:newDelegate;

- datasource;
- (void) setDatasource:newDatasource;

- (void) drawRect:(NSRect)rect;
- (void) mouseDown:(NSEvent *)theEvent;
#if 0
//- (BOOL) trackMouse:(NSEvent *)theEvent inRect:(NSRect)aRect;
- (BOOL) dragWindow:(NSWindow *)dragWindow
         fromOrigin:(NSPoint)originalWindowOrigin
             inRect:(NSRect)aRect
         firstEvent:(NSEvent *)theEvent;
#endif
- (void) mouseUp:(NSEvent *)theEvent;

- (void) update;

//----------------------------------------------------------------------
// Covers for datasource methods
//----------------------------------------------------------------------

- (BOOL) shouldAutoLaunch;
- (BOOL) shouldAnimate;
- (BOOL) isPersistent;

- (BOOL) isRunning;
- (BOOL) isSelected;
- (BOOL) isGhosted;
- (NSImage *) animatedImage;

//----------------------------------------------------------------------
// Covers for delegate messages
//----------------------------------------------------------------------

- (void) launchApplicationAndHideOthers:(BOOL)hideOthers;
- (void) singleClicked;
- (void) toggleTileSelected;

//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

- (NSWindow *) _tileWindow:(BOOL)isShadowedWindow;

@end

@protocol FIIconViewDelegateProtocol
- (void) selectApplicationInWorkspace:sender;
- (void) launchApplication:sender hideOthers:(BOOL)hideOthers;
- (void) toggleTileSelected:sender;
@end

@protocol FITileViewDelegateProtocol
- (void) tileDidDragWindow:(NSWindow *)shadowWindow locationOffset:(DockLocation)offset;
- (void) tileDidDragToOffset:(DockLocation)offset;
@end
