#import "Fiend.h"

RCSID ("$Id: Fiendish.m,v 1.2 1998/09/03 01:30:55 nygard Exp $");

#import "Fiendish.h"
#import <AppKit/psopsNeXT.h>
#import "FiendWraps.h"
#import "table.h"

// 0: success, -1: error

int safeGetCurrentOwner (int globalWindowNumber, int *ownerContext)
{
    int status = 0;

    *ownerContext = 0;

    if (globalWindowNumber <= 0)
        return -1;

    NS_DURING
        {
            // Calling PScurrentowner() doesn't seem to work.
            //PScurrentowner (globalWindowNumber, ownerContext);

            PSWGetCurrentOwner (globalWindowNumber, ownerContext);
        }
    NS_HANDLER
        {
            if ([localException name] == DPSPostscriptErrorException)
            {
                status = -1;
            }
            else
            {
                [localException raise];
            }
            //NSLog (@"localException: %@", localException);
            //NSLog (@"%@, reason: %@", [localException name], [localException reason]);
            //NSLog (@"userInfo: %@", [localException userInfo]);
        }
    NS_ENDHANDLER;

    return status;
}

//----------------------------------------------------------------------

int safeGetTokenWindowAndPid (int ownerContext, int *tokenWindowNumber, int *pid)
{
    int status = 0;

    *tokenWindowNumber = 0;
    *pid = 0;

    if (ownerContext < 0)
        return -1;

    NS_DURING
        {
            PSWGetCtxtIconAndPid (ownerContext, tokenWindowNumber, pid);
        }
    NS_HANDLER
        {
            if ([localException name] == DPSPostscriptErrorException)
            {
                status = -1;
            }
            else
            {
                [localException raise];
            }
        }
    NS_ENDHANDLER;

    return status;
}

//----------------------------------------------------------------------

int safeCopyWindow (float x, float y, float width, float height, int globalWindowNumber)
{
    int status = 0;

    if (globalWindowNumber < 0)
        return -1;

    NS_DURING
        {
            PSWCopyWindow (x, y, width, height, globalWindowNumber);
        }
    NS_HANDLER
        {
            if ([localException name] == DPSPostscriptErrorException)
            {
                status = -1;
            }
            else
            {
                [localException raise];
            }
        }
    NS_ENDHANDLER;

    return status;
}

//----------------------------------------------------------------------

int safeUnhideContext (int ownerContext, BOOL raise, BOOL makeActive, BOOL hideOthers)
{
    int status = 0;

    if (ownerContext < 0)
        return -1;

    NS_DURING
        {
            PSWUnhideContext (ownerContext, raise, makeActive, hideOthers);
        }
    NS_HANDLER
        {
            if ([localException name] == DPSPostscriptErrorException)
            {
                status = -1;
            }
            else
            {
                [localException raise];
            }
        }
    NS_ENDHANDLER;

    return status;
}
