#import "Fiend.h"

RCSID ("$Id: GeneralPreferencesController.m,v 1.1.1.1 1998/09/03 01:14:56 nygard Exp $");

#import "GeneralPreferencesController.h"

DEFINE_NSSTRING (FIPreferencesHideTilesDidChangeNotification);
DEFINE_NSSTRING (FIPreferencesShowLevelNumberDidChangeNotification);
DEFINE_NSSTRING (FIPreferencesShowFlagCuesDidChangeNotification);

@implementation GeneralPreferencesController

- init
{
    if ([super initWithWindowNibName:@"GeneralPreferences"] == nil)
        return nil;

    optionsMatrix = nil;

    return self;
}

//----------------------------------------------------------------------

- (BOOL) centerViewHorizontally
{
    return YES;
}

//----------------------------------------------------------------------

- (void) willSwapInContentView
{
    NSUserDefaults *defaults;
    
    defaults = [NSUserDefaults standardUserDefaults];
    [[optionsMatrix cellWithTag:0] setState:[defaults boolForKey:DK_UseSounds]];
    [[optionsMatrix cellWithTag:1] setState:[defaults boolForKey:DK_StrictCopy]];
    [[optionsMatrix cellWithTag:2] setState:[defaults boolForKey:DK_HideTiles]];
    [[optionsMatrix cellWithTag:3] setState:[defaults boolForKey:DK_ShowLevelNumber]];
    [[optionsMatrix cellWithTag:4] setState:[defaults boolForKey:DK_ClosePostLaunch]];
    [[optionsMatrix cellWithTag:5] setState:[defaults boolForKey:DK_EnableSingleClick]];
    [[optionsMatrix cellWithTag:6] setState:[defaults boolForKey:DK_ShowFlagCues]];
}

//----------------------------------------------------------------------

- (void) toggleOption:sender
{
    NSUserDefaults *defaults;
    NSCell *selectedCell;
    int tag, state;

    defaults = [NSUserDefaults standardUserDefaults];
    selectedCell = [sender selectedCell];
    tag = [selectedCell tag];
    state = [selectedCell state];
    switch (tag)
    {
      case 0:
          [defaults setBool:state forKey:DK_UseSounds];
          break;

      case 1:
          [defaults setBool:state forKey:DK_StrictCopy];
          break;

      case 2:
          [defaults setBool:state forKey:DK_HideTiles];
          [[NSNotificationCenter defaultCenter] postNotificationName:FIPreferencesHideTilesDidChangeNotification object:nil];
          break;

      case 3:
          [defaults setBool:state forKey:DK_ShowLevelNumber];
          [[NSNotificationCenter defaultCenter] postNotificationName:FIPreferencesShowLevelNumberDidChangeNotification object:nil];
          break;

      case 4:
          [defaults setBool:state forKey:DK_ClosePostLaunch];
          break;

      case 5:
          [defaults setBool:state forKey:DK_EnableSingleClick];
          break;

      case 6:
          [defaults setBool:state forKey:DK_ShowFlagCues];
          [[NSNotificationCenter defaultCenter] postNotificationName:FIPreferencesShowFlagCuesDidChangeNotification object:nil];
          break;

      default:
          // Do nothing.
          break;
    }
}

@end
