#import "Fiend.h"

RCSID ("$Id: NameLevelController.m,v 1.1.1.1 1998/09/03 01:14:54 nygard Exp $");

#import "NameLevelController.h"

#import "FIDock.h"
#import "FILevel.h"

// Needs to be able to get and set the current dock level name.

@implementation NameLevelController

+ sharedNameLevelController
{
    static NameLevelController *instance = nil;

    if (instance == nil)
        instance = [[NameLevelController alloc] init];

    return instance;
}

//----------------------------------------------------------------------

- init
{
    if ([super initWithWindowNibName:@"NameLevelPanel"] == nil)
        return nil;

    [self setWindowFrameAutosaveName:@"NameLevelPanel"];

    return self;
}

//----------------------------------------------------------------------

- (void) showWindow:sender
{
    if ([self isWindowLoaded] == YES)
        [self revert];
    
    [super showWindow:sender];
}

//----------------------------------------------------------------------

- (void) windowDidLoad
{
    [super windowDidLoad];
    [self revert];
}

//----------------------------------------------------------------------

- (void) revert
{
    NSString *currentLevelName;

    currentLevelName = [[[FIDock instance] currentLevel] levelName];
    if (currentLevelName == nil)
        currentLevelName = @"";
    [levelNameTextField setStringValue:currentLevelName];
}

//----------------------------------------------------------------------

- (void) cancelAction:sender
{
    [[self window] orderOut:self];
}

//----------------------------------------------------------------------

- (void) okayAction:sender
{
    NSString *levelName;
    
    //NSLog (@"levelName: %@", [levelNameTextField stringValue]);
    levelName = [levelNameTextField stringValue];
    if ([levelName isEqual:@""])
        levelName = nil;
    [[[FIDock instance] currentLevel] setLevelName:levelName];
    [[self window] orderOut:self];
}

@end
