#import "Fiend.h"

RCSID ("$Id: PreferencePanelController.m,v 1.2 1998/09/03 01:31:00 nygard Exp $");

#import "PreferencePanelController.h"

#import "FISwapView.h"
#import "FISwappedViewController.h"
#import "TilePlacementView.h"

#import "GeneralPreferencesController.h"
#import "TilePlacementController.h"

@implementation PreferencePanelController

+ sharedPreferencePanelController
{
    static PreferencePanelController *instance = nil;

    if (instance == nil)
        instance = [[PreferencePanelController alloc] init];

    return instance;
}

//----------------------------------------------------------------------

- init
{
    if ([super initWithWindowNibName:@"PreferencePanel"] == nil)
        return nil;

    preferenceControllers = [[NSMutableArray array] retain];
    [preferenceControllers addObject:[[[GeneralPreferencesController alloc] init] autorelease]];
    [preferenceControllers addObject:[[[TilePlacementController alloc] init] autorelease]];

    [self setWindowFrameAutosaveName:@"PreferencePanel"];

    return self;
}

//----------------------------------------------------------------------

- (void) dealloc
{
    SNRelease (preferenceControllers);

    [super dealloc];
}

//----------------------------------------------------------------------

- (void) windowDidLoad
{
    [super windowDidLoad];

    [swapView setSwappedViewController:[preferenceControllers objectAtIndex:0]];
}

//----------------------------------------------------------------------

- (void) changeMode:sender
{
    int index;

    index = [sender indexOfSelectedItem];

    NSParameterAssert (index >= 0 && index < [preferenceControllers count]);

    [swapView setSwappedViewController:[preferenceControllers objectAtIndex:index]];
}

@end
