#import "Fiend.h"

RCSID ("$Id: TilePlacementController.m,v 1.1.1.1 1998/09/03 01:14:56 nygard Exp $");

#import "TilePlacementController.h"

#import "TilePlacementView.h"

DEFINE_NSSTRING (FIPreferencesTilePlacementDidChangeNotification);

@implementation TilePlacementController

- init
{
    if ([super initWithWindowNibName:@"TilePlacementPreferences"] == nil)
        return nil;

    tilePlacementView = nil;

    return self;
}

//----------------------------------------------------------------------

- (void) windowDidLoad
{
    [super windowDidLoad];

    [tilePlacementView setAction:@selector (changePlacement:)];
    [tilePlacementView setTarget:self];
}

//----------------------------------------------------------------------

- (void) revertToDefaults
{
    NSUserDefaults *defaults;

    defaults = [NSUserDefaults standardUserDefaults];
    [tilePlacementView setCorner:FITileCornerFromString ([defaults objectForKey:DK_FiendTileCorner])];
    [tilePlacementView setFillVertically:[defaults boolForKey:DK_PlaceTilesVertically]];
}

//----------------------------------------------------------------------

- (void) updateDefaults
{
    NSUserDefaults *defaults;

    defaults = [NSUserDefaults standardUserDefaults];
    [defaults setObject:NSStringFromFiendTileCorner ([tilePlacementView corner]) forKey:DK_FiendTileCorner];
    [defaults setBool:[tilePlacementView fillVertically] forKey:DK_PlaceTilesVertically];
    [[NSNotificationCenter defaultCenter] postNotificationName:FIPreferencesTilePlacementDidChangeNotification object:nil];
}

//----------------------------------------------------------------------

- (void) willSwapInContentView
{
    [self revertToDefaults];
}

//----------------------------------------------------------------------

- (void) changePlacement:sender
{
    [self updateDefaults];
}

@end
