#import "Fiend.h"

RCSID ("$Id: TileSettingsController.m,v 1.1.1.1 1998/09/03 01:14:54 nygard Exp $");

#import "TileSettingsController.h"

#import "FIDock.h"
#import "FILevel.h"
#import "FITile.h"

// Needs to be able to get and set the current dock level name.

@implementation TileSettingsController

- initWithDock:(FIDock *)aDock
{
    BOOL loaded;
    NSString *nibFile;

    if ([super init] == nil)
        return nil;

    nibFile = @"TileSettingsWindow.nib";
    loaded = [NSBundle loadNibNamed:nibFile owner:self];
    if (loaded == NO)
    {
        NSLog (@"Could not load %@.", nibFile);
        [super dealloc];
        return nil;
    }

    nonretainedDock = aDock;

    [window setFrameAutosaveName:[window title]];

    return self;
}

//----------------------------------------------------------------------

- (void) dealloc
{
    SNRelease (window);
    
    [super dealloc];
}

//----------------------------------------------------------------------

- (void) showWindowForTile:(FITile *)theTile
{
    nonretainedTile = theTile;

    [pathTextField setStringValue:[nonretainedTile path]];
    [autolaunchCell setIntValue:[nonretainedTile shouldAutoLaunch]];
    [animateCell setIntValue:[nonretainedTile shouldAnimate]];
    [persistCell setIntValue:[nonretainedTile isPersistent]];

    //[window makeKeyAndOrderFront:self];
    [NSApp runModalForWindow:window];
}

//----------------------------------------------------------------------

- (void) cancelAction:sender
{
    [window orderOut:self];
    [NSApp stopModal];

    [NSApp sendAction:@selector (deselectAllTiles:) to:nil from:self];
}

//----------------------------------------------------------------------

- (void) okayAction:sender
{
    BOOL shouldAutoLaunch;
    BOOL shouldAnimate;
    BOOL isPersistent;
    
    shouldAutoLaunch = [autolaunchCell intValue];
    shouldAnimate = [animateCell intValue];
    isPersistent = [persistCell intValue];

    if (shouldAutoLaunch != [nonretainedTile shouldAutoLaunch])
    {
        [nonretainedTile setShouldAutoLaunch:shouldAutoLaunch];
        [nonretainedDock updateChangeCount];
    }

    if (shouldAnimate != [nonretainedTile shouldAnimate])
    {
        [nonretainedTile setShouldAnimate:shouldAnimate];
        [nonretainedDock updateChangeCount];
    }

    if (isPersistent != [nonretainedTile isPersistent])
    {
        //NSLog (@"isPersistent changed...");
        [nonretainedDock togglePersistenceOfTile:nonretainedTile];
    }

    [window orderOut:self];
    [NSApp stopModal];

    [NSApp sendAction:@selector (deselectAllTiles:) to:nil from:self];
}

@end
